SystemOrganization addCategory: #'Settings-Tools'!

Object subclass: #BrowserSystemSettings
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Settings-Tools'!

!BrowserSystemSettings class methodsFor: 'settings' stamp: 'AlainPlantec 5/31/2010 09:23'!
defaultBrowserSettingOn: aBuilder
	<systemsettings>
	(aBuilder pickOne: #defaultBrowser)
			order: -1;
			parent: #codeBrowsing;
			target: SystemBrowser;
			getSelector: #default;
			setSelector: #default:;
			label: 'Default browser' translated;
			domainValues: SystemBrowser registeredClasses! !

Object subclass: #CodeHolderSystemSettings
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Settings-Tools'!

!CodeHolderSystemSettings class methodsFor: 'settings' stamp: 'FedericoScarpa 5/28/2011 13:46'!
codeBrowsingSettingsOn: aBuilder 
	<systemsettings>  
	(aBuilder group: #codeBrowsing) 
		label: 'Code browsing' translated;
		target: CodeHolder;
		description: 'All settings concerned with code browsing look''n feel' translated;
		with: [	
			(aBuilder setting: #browseWithPrettyPrint) 
				order: 1;
				label: 'Pretty print' translated;
		 		description: 'If checked then browsers automatically format their code' translated.
			(aBuilder setting: #showAnnotationPane) 
				label: 'Show annotation pane' translated;
		 		description: 'If checked then the annotation pane is shown in browsers; it is dynamically updated with useful informations about the code which is currently browsed' translated.
			(aBuilder group: #ChangeSorter)
				label: 'Change sorter' translated;
				description: 'Change sorter specific settings' translated;
				with: [
					(aBuilder setting: #mustCheckForSlips)
						target: ChangeSet;
						label: 'Check for slips' translated;
						description: 'If true, then whenever you file out a change set, it is checked for ''slips'' and if any are found, you are so informed and given a chance to open a browser on them' translated.
					(aBuilder setting: #diffsInChangeList)
						label: 'Exhibits differences' translated;
						description: 'If true, ChangeList browsers and Versions browsers will open up by default showing differences, i.e. revealing the differences between successive versions or between the in-memory code and the code on disk' translated;
						with: [
							(aBuilder setting: #diffsWithPrettyPrint)
								label: 'Pretty print differences' translated;
								description: 'If true, displays of source code differences will be pretty-printed first' translated]]]! !

!CodeHolderSystemSettings class methodsFor: 'settings' stamp: 'AlainPlantec 2/11/2011 21:55'!
codeEditingSettingsOn: aBuilder 
	<systemsettings> 
	(aBuilder group: #codeEditing) 
		label: 'Editing' translated;
		parent: #codeBrowsing; 
		noOrdering;
		description: 'All settings concerned with text editing' translated;
		with: [	
			(aBuilder setting: #selectionColor)
				target: UITheme;
				targetSelector: #currentSettings;
				label: 'Selection color' translated.
			(aBuilder setting: #unfocusedSelectionColor)
				target: UITheme;
				targetSelector: #currentSettings;
				description: 'The color of the selection for unfocused windows' translated;
				label: 'Unfocused selection color' translated.
			(aBuilder setting: #selectionTextColor)
				target: UITheme;
				targetSelector: #currentSettings;
				label: 'Selection text color' translated;
				description: 'The color of the selection text' translated.
			(aBuilder setting: #useSelectionBar)
				target: TextEditor;
				label: 'Show the colored bar on the current line' translated;
				with: [
					(aBuilder setting: #selectionBarColor)
						target: UITheme;
						targetSelector: #currentSettings;
						label: 'Selection bar color' translated].
			(aBuilder setting: #useSecondarySelection)
				target: TextEditor;
				label: 'Use the secondary selection' translated;
				with: [
					(aBuilder setting: #secondarySelectionColor)
						target: UITheme;
						targetSelector: #currentSettings;
						label: 'Secondary selection color' translated.
					(aBuilder setting: #secondarySelectionTextColor)
						target: UITheme;
						targetSelector: #currentSettings;
						label: 'Secondary selection text color' translated].
			(aBuilder setting: #useFindReplaceSelection)
				target: TextEditor;
				label: 'Use the find and replace selection' translated;
				with: [
					(aBuilder setting: #findReplaceSelectionColor)
						target: UITheme;
						targetSelector: #currentSettings;
						label: 'Find replace selection color' translated.
					(aBuilder setting: #findReplaceSelectionTextColor)
						target: UITheme;
						targetSelector: #currentSettings;
						label: 'Find replace selection text color' translated].
			(aBuilder setting: #caseSensitiveFinds) 
				label: 'Case sensitive search' translated;
				target: TextEditor;
		 		description: 'If true, then the "find" command in text will always make its searches in a case-sensitive fashion' translated.
			(aBuilder setting: #blinkingCursor) 
				label: 'Blinking text cursor' translated;
				target: Editor;
		 		description: 'When true, the text cursor will blink.' translated.
			(aBuilder setting: #dumbbellCursor) 
				label: 'Dumbbell-shaped text cursor' translated;
				target: Editor;
		 		description: 'When true, the text cursor assumes the shape of a dumbbell, otherwise a vertical bar.' translated.
			(aBuilder setting: #walkAlongDisplayedLine) 
				label: 'Walk along displayed line' translated;
				target: TextEditor;
		 		description: 'If set to true cursor movement will move along displayed lines rather than logical lines' translated.
			(aBuilder setting: #smartUpdating)
				label: 'Smart updating' translated;
				target: CodeHolder;
				description: 'If true, then morphic tools such as browsers and inspectors will keep their contents up to date automatically, so that if something changes anywhere, the change will be reflected everywhere' translated.
		]
! !

Object subclass: #DebugSystemSettings
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Settings-Tools'!

!DebugSystemSettings class methodsFor: 'settings' stamp: 'MarcusDenker 5/28/2011 20:24'!
debugSettingsOn: aBuilder
	<systemsettings>
	(aBuilder group: #debugging)
		label: 'Debugging';
		with: [
			(aBuilder group: #deprecationHandling)
				label: 'Deprecation handling' translated;
				description: 'How deprecation are handled' translated;
				target: Deprecation;
				with: [
					(aBuilder setting: #raiseWarning)
						label: 'Raise a blocking dialog' translated;
						description: 'If true, then a dialog is popup for each deprecated method invocation' translated.
					(aBuilder setting: #showWarning)
						label: 'Transcript message' translated;
						description: 'If true, then a message is send to the Transcript for each deprecated method invocation' translated].
			
			(aBuilder setting: #cmdDotEnabled)
				label: 'Enable cmd-dot interrupt key' translated;
				target: UserInterruptHandler;
				description: 'If true, it allows the user to stop currently running process by opening-up a debugger' translated.
			
			(aBuilder setting: #cpuWatcherEnabled)
				label: 'Process browser monitors CPU usage' translated;
				target: CPUWatcher;
				description: 'If true, Pharo processes will be monitored for CPU usage. If they take too much CPU, you will get a notification menu that will allow you to debug, resume, or terminate the process' translated.
			
			(aBuilder setting: #debugShowDamage)
				label: 'Flash damaged morphic region' translated;
				target: WorldState;
				description: 'If true, every changed region of the morphic display will be flashed black before updating.' translated.
			
			(aBuilder setting: #logDebuggerStackToFile)
				label: 'Write message to debug log file when fall into debugger' translated;
				target: Debugger;
				description: 'If true, whenever you fall into a debugger a summary of its stack will be written to a file named' translated.
			
			(aBuilder setting: #restartAlsoProceeds)
				label: 'Restart also proceeds' translated;
				target: Debugger;
				description: 'If this preference is set, the debugger''s restart button and menu item will also proceed. If the preference is not set, the selected context will just be reset to its initial condition, so you may step through it again.' translated.
				
			(aBuilder setting: #alwaysOpenFullDebugger)
				label: 'Directly open the full Debugger' translated;
				target: Debugger;
				description: 'When true, always directly open the full Debugger view when debugging instead of showing only a small popup' translated.
				
			(aBuilder setting: #ObjectExplorerShowIcons)
				label: 'Icons in explorer' translated;
				selector: #showIcons;
				target: ObjectExplorer;
				description: 'When possible, show icon in explorer.' translated.
				
			(aBuilder setting: #logFileName)
				label: 'Log file name' translated;
				target: Debugger;
				description: 'A name of the file, which will be used for logging all errors and notifications' 
		]! !

Object subclass: #DifferatorSystemSettings
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Settings-Tools'!

!DifferatorSystemSettings commentStamp: 'HenrikSperreJohansen 5/21/2010 02:43' prior: 0!
My settings allow the user to choose whether different line endings will be shown in diffs,
and the colors/emphasis used for added/removed text!

!DifferatorSystemSettings class methodsFor: 'settings' stamp: 'HenrikSperreJohansen 5/21/2010 02:42'!
differatorSettingsOn: aBuilder 
	<systemsettings>
	(aBuilder group: #differator) 
		label: 'Differator' translated;
		parent: #codeBrowsing; 
		description: 'All settings concerned with the differator' translated;
		with: [	
			(aBuilder setting: #ignoreLineEndings) 
				label: 'Ignore line endings' translated;
				target: TextDiffBuilder;
		 		description: 'When selected, line ending differences will be ignored ' translated.
				
		"Don't quite know how to build these... Should be able to choose emphasis and highlight-color"
			"(aBuilder setting: #insertedTextAttributes) 
				label: 'Inserted text' translated;
				target: TextDiffBuilder;
		 		description: 'Select how inserted text will be displayed' translated.
			(aBuilder setting: #removedTextAttributes) 
				label: 'Removed text' translated;
				target: TextDiffBuilder;
		 		description: 'Select how removed text will be displayed' translated."
		]
! !
